﻿using System;
using System.Windows.Input;

namespace NET45SelectorBugWithChangingHash
{
    public class DelegateCommand : ICommand
    {
        private readonly Action<object> _executeDelegate;
        private readonly Func<object, bool> _canExecuteDelegate;

        public DelegateCommand(Action<object> executeDelegate, bool canExecute)
            : this(executeDelegate, o => canExecute)
        {
            
        }

        public DelegateCommand(Action<object> executeDelegate, Func<object, bool> canExecuteDelegate)
        {
            _executeDelegate = executeDelegate;
            _canExecuteDelegate = canExecuteDelegate;
            if (executeDelegate == null) throw new ArgumentNullException("executeDelegate");
            if (canExecuteDelegate == null) throw new ArgumentNullException("canExecuteDelegate");
            
        }

        public void Execute(object parameter)
        {
            _executeDelegate(parameter);
        }

        public bool CanExecute(object parameter)
        {
            return _canExecuteDelegate(parameter);
        }

        public event EventHandler CanExecuteChanged;
    }
}