﻿using System.ComponentModel;

namespace NET45SelectorBugWithChangingHash
{
    public class Item : INotifyPropertyChanged
    {
        private int _id;
        private string _name;

        public int ID
        {
            get { return _id; }
            set { _id = value; OnPropertyChanged("ID"); }
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged("Name"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public override int GetHashCode()
        {
            return _id; // items with the same id should represent the same item
        }
    }
}