﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Data;

namespace NET45SelectorBugWithChangingHash
{
    public class ViewModel
    {
        private CollectionViewSource _itemsView;

        public ViewModel()
        {
            Items = new ObservableCollection<Item>();
            Items.Add(new Item { ID = 10, Name = "David" });
            Items.Add(new Item { ID = 20, Name = "Jenny" });
            Items.Add(new Item { ID = 30, Name = "Phillip" });
            Items.Add(new Item { ID = 40, Name = "Cassandra" });
        }

        public ObservableCollection<Item> Items { get; private set; }

        public ICollectionView ItemsView
        {
            get
            {
                if (_itemsView == null)
                {
                    _itemsView = new CollectionViewSource();
                    _itemsView.Source = Items;
                }

                return _itemsView.View;
            }
        }

        
    }
}
